import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.text.*;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeEvent;

class Budgetele extends JFrame implements ActionListener, PropertyChangeListener{
	private static final long serialVersionUID = -1154451023773719212L;
    File f;
    JScrollPane sp = new JScrollPane();
    JPanel main = new JPanel(new GridBagLayout());
    JPanel bot = new JPanel(new GridLayout(1,5));
    JLabel pnum = new JLabel("Project #1");
    JLabel empty = new JLabel("");
    JButton save = new JButton("save");
    JButton cancel = new JButton("exit");
    JComponent field[][] = new JComponent[100][10];
    JComponent test = new JTextField();
    
    String fname;
    String mat[] = new String[200];
    String matunit[] = new String[200];
    double matcost[] = new double[200];
    double moolelo[] = new double[200];
    double matco2[] = new double[200];
    
    globalvar g;
    
    //double ptotal = 0;
    double sum = 0;
    double num = 0;
    double tax = 1.13;
    int row = 0;
    int col = 0;
    
    //private NumberFormat doubleFormat;
    private GridBagConstraints material = new GridBagConstraints();
    private GridBagConstraints labour = new GridBagConstraints();
    private GridBagConstraints co2score = new GridBagConstraints();
    
    
    public Budgetele(String filename, globalvar globe){
        super(filename);
        
        //grab lists and tax from global
        g = globe;
        mat = g.updateList();
        matunit = g.updateUnit();
        matcost = g.updateCost();
        moolelo = g.updateMo();
        matco2 = g.updateCO2();
        tax = g.getTax();
        
        //initialize titles and grid
        init();
        title(filename);
        fname = g.getDirectory()+"/Element/"+filename+".txt";
        readElement();
        
        //doubleFormat = NumberFormat.getCurrencyInstance();
        
        //starting gbc's
        material.fill = GridBagConstraints.HORIZONTAL;
        labour.fill = GridBagConstraints.HORIZONTAL;
        co2score.fill = GridBagConstraints.HORIZONTAL;
        
        material.ipady = 0;         
        material.weightx = 0.2;
        material.weighty = 0.02;
        labour.ipady = 0;
        labour.weightx = 0.1;
        labour.weighty = 0.02;
        co2score.weightx = 0.05;
        co2score.weighty = 0.02;
        
        
        ////>
        for(row = 0; row <5; row++){
            material.gridx = 0;
            material.gridy = row;
            labour.gridx = 0;
            labour.gridy = row;
            for(col = 0; col<7; col++){
                if(col == 0 || col == 6){
                    main.add(field[row][col],material);
                    material.gridx = 6;
                    labour.gridx = 1;
                }else{
                    main.add(field[row][col],labour);
                    labour.gridx++;
                }
            }
        }
        for(row = 5;row<=25;row++){
            material.gridx = 0;
            material.gridy = row;
            labour.gridx = 0;
            labour.gridy = row;
            co2score.gridx = 5;
            co2score.gridy = row;
            for(col = 0; col<8; col++){
                if(col == 0){
                    main.add(field[row][col],material);
                    labour.gridx = 1;
                }else if(col>0 && col<5){
                    main.add(field[row][col],labour);
                    labour.gridx++;
                }
                /*else if(col == 5){
                 main.add(field[row][col],material);
                 labour.gridx = 6;
                 }*/
                else{
                    main.add(field[row][col],co2score);
                    co2score.gridx++;
                }
            }
        }
        cancel.addActionListener(this);
        save.addActionListener(this);
        bot.add(cancel);
        bot.add(empty);
        bot.add(save);
        ////
        sp.getViewport().add(main);
        setLayout(new BorderLayout());
        add(sp, BorderLayout.CENTER);
        add(bot, BorderLayout.SOUTH);
        pack();
		setSize(1000,500);
		setResizable(true);
		setVisible(true);
		//setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    }
    public void init(){        
        /////////////////////////// preset all fields
        for(int i = 0; i<100; i++){
            for(int j = 0; j<8; j++){
                if(i==0 && j<6){
                    field[i][j] = new JLabel();
                }else if((i==1||i==2) && j==4){
                	field[i][j] = new JFormattedTextField(NumberFormat.getNumberInstance());
                	((JFormattedTextField)field[i][j]).setEditable(false);
                }else if((i==1||i==2) && (j==0||j==1||j==5)){
                    field[i][j] = new JLabel();
                }else if(i==3 && j==4){
                    field[i][j] = new JFormattedTextField(NumberFormat.getNumberInstance());
                    ((JFormattedTextField)field[i][j]).setEditable(false);
                }else if((i==3||i==4) && j<6){
                    field[i][j] = new JLabel();
                }else if((i>=0&&i<=4)&& j==6){
                    field[i][j] = new JLabel();
                }else if(i==5){
                    field[i][j] = new JLabel();
                }else if(i>5 && i<=21 && j==0){
                    field[i][j] = new JComboBox(mat);
                    ((JComboBox)field[i][j]).addActionListener(this);
                }else if(i>5 && i<=21 && j==1){
                    field[i][j] = new JLabel();
                }else if(i>21 && i<=23 && (j==0 || j==1)){
                	field[i][j] = new JTextField("-");
                	((JTextField)field[i][j]).addActionListener(this);
                }else if(i>5 && i<=23 && j>=4 && j<=7){
                    field[i][j] = new JFormattedTextField(NumberFormat.getNumberInstance());
                    ((JFormattedTextField)field[i][j]).setEditable(false);
                }else if(i==25 && (j>=4 && j<=7)){
                    field[i][j] = new JFormattedTextField(NumberFormat.getNumberInstance());
                    ((JFormattedTextField)field[i][j]).setEditable(false);
                }else if(i==24 || i==25){
                    field[i][j] = new JLabel();
                }else{
                    field[i][j] = new JFormattedTextField(NumberFormat.getNumberInstance());
                    field[i][j].addPropertyChangeListener("value",this);
                }
                if(i>=1 && i<=3 && j==0){
                    ((JLabel)field[i][j]).setText(" ");
                    ((JLabel)field[i][j]).setOpaque(true);
                    ((JLabel)field[i][j]).setBackground(Color.yellow);
                }
            }
        }
    }
    public void title(String filename){
        ((JLabel)field[0][0]).setText("Project");
        ((JLabel)field[0][1]).setText("LABOUR");
        ((JLabel)field[0][2]).setText("Hours");
        ((JLabel)field[0][3]).setText("Rate");
        ((JLabel)field[0][4]).setText("Totals");
        ((JLabel)field[0][5]).setText("Production:");
        
        ((JLabel)field[1][1]).setText("Set Labour:");
        ((JLabel)field[1][5]).setText("Theatre:");
        
        ((JLabel)field[2][0]).setText(filename);
        ((JLabel)field[2][1]).setText("Paint Labour:");
        ((JLabel)field[2][5]).setText("Version:");
        
        ((JLabel)field[3][1]).setText("Set Materials:");
        ((JLabel)field[3][5]).setText("Date:");
        
        ((JLabel)field[4][3]).setText("Project Total:");
        ((JLabel)field[4][3]).setOpaque(true);
        ((JLabel)field[4][3]).setBackground(Color.yellow);
        
        ((JLabel)field[5][0]).setText("Material");
        ((JLabel)field[5][1]).setText("Unit");
        ((JLabel)field[5][2]).setText("Cost Per");
        ((JLabel)field[5][3]).setText("Quantity");
        ((JLabel)field[5][4]).setText("Cost & Tax");
        ((JLabel)field[5][5]).setText("CO2ekg");
        ((JLabel)field[5][6]).setText("Green Score");
        ((JLabel)field[5][7]).setText("Result CO2ekg");
        
        ((JLabel)field[24][0]).setText("");
        ((JLabel)field[24][1]).setText("");
        ((JLabel)field[24][2]).setText("");
        ((JLabel)field[24][3]).setText("");
        ((JLabel)field[24][4]).setText("Cost & Tax");
        ((JLabel)field[24][5]).setText("CO2ekg");
        ((JLabel)field[24][6]).setText("Green Score");
        ((JLabel)field[24][7]).setText("Result CO2ekg");
        
        ((JLabel)field[25][3]).setText("Materials Total:");
        ((JLabel)field[25][3]).setOpaque(true);
        ((JLabel)field[25][3]).setBackground(Color.yellow);
        
    }
    public void actionPerformed(ActionEvent e){ //database data gathering here
        Object source = e.getSource();
        if(source.equals(save)){
            try{
                saveElement();
            }catch(IOException ie){
                System.out.println("file not found");
            }
        }else{
            for(int i = 6; i<22;i++){ //determine selected values
                if(source.equals(field[i][0])){
                    int select = ((JComboBox)field[i][0]).getSelectedIndex();
                    ((JLabel)field[i][1]).setText(matunit[select]);
                    ((JFormattedTextField)field[i][2]).setValue(matcost[select]);
                    ((JFormattedTextField)field[i][5]).setValue(matco2[select]);
                    ((JFormattedTextField)field[i][6]).setValue(moolelo[select]);
                    ((JFormattedTextField)field[i][6]).setOpaque(true);
                    if(moolelo[select]==4)
                        ((JFormattedTextField)field[i][6]).setBackground(Color.green);
                    else if(moolelo[select]==3)
                        ((JFormattedTextField)field[i][6]).setBackground(Color.yellow);
                    else if(moolelo[select]==2)
                        ((JFormattedTextField)field[i][6]).setBackground(Color.pink);
                    else if(moolelo[select]==1)
                        ((JFormattedTextField)field[i][6]).setBackground(Color.orange);
                    else if(moolelo[select]==0)
                        ((JFormattedTextField)field[i][6]).setBackground(Color.red);
                }
            }
        }
        if(source.equals(cancel)){
            dispose();
        }
    }
    public void updateMat(){
        g.updateList();
    }
    
    public void propertyChange(PropertyChangeEvent e){ //calculations here
        Object source = e.getSource();
        // Check to see which field was changed
        for(int i = 6; i<24; i++){
        	//If blank items change
        	/*if(source.equals(field[i][2]) || source.equals(field[i][3])){
                if(((JFormattedTextField)field[i][2]).getValue()!=null &&((JFormattedTextField)field[i][3]).getValue()!=null){
                	sum = ((Number)((JFormattedTextField)field[i][2]).getValue()).doubleValue() * ((Number)((JFormattedTextField)field[i][3]).getValue()).doubleValue() * tax;
                    sum = sum * 100;
                    sum = Math.round(sum);
                    sum = sum / 100;
                    ((JFormattedTextField)field[i][4]).setValue(sum);
                }
        	}*/
            //If cost or quantity changes, change total
            if(source.equals(field[i][2])||source.equals(field[i][3])){
                sum = 0;
                if(((JFormattedTextField)field[i][2]).getValue()!=null &&((JFormattedTextField)field[i][3]).getValue()!=null){
                    sum = ((Number)((JFormattedTextField)field[i][2]).getValue()).doubleValue() * ((Number)((JFormattedTextField)field[i][3]).getValue()).doubleValue() * tax;
                    sum = sum * 100;
                    sum = Math.round(sum);
                    sum = sum / 100;
                    ((JFormattedTextField)field[i][4]).setValue(sum);
                }
            }
            //If quantity changes and != null multiply find total CO2
            if(i<22 && source.equals(field[i][3])&&((JFormattedTextField)field[i][3]).getValue()!=null){
                //Recalculate CO2 for material
                int select = ((JComboBox)field[i][0]).getSelectedIndex();
                sum = matco2[select] * ((Number)((JFormattedTextField)field[i][3]).getValue()).doubleValue();
                ((JFormattedTextField)field[i][5]).setValue(sum);
                if(moolelo[select]==4)
                    sum = ((Number)((JFormattedTextField)field[i][5]).getValue()).doubleValue()*0.6;
                else if(moolelo[select]==3)
                    sum = ((Number)((JFormattedTextField)field[i][5]).getValue()).doubleValue()*0.7;
                else if(moolelo[select]==2)
                    sum = ((Number)((JFormattedTextField)field[i][5]).getValue()).doubleValue()*0.8;
                else if(moolelo[select]==1)
                    sum = ((Number)((JFormattedTextField)field[i][5]).getValue()).doubleValue()*0.9;
                else
                    sum = ((Number)((JFormattedTextField)field[i][5]).getValue()).doubleValue();
                ((JFormattedTextField)field[i][7]).setValue(sum);
            }
        }
        double sum1 = 0, sum2 = 0, sum3 = 0, sum4 = 0;
        int count = 0;
        for(int j = 6; j<24; j++){
            
            //sum of Total
            if(((JFormattedTextField)field[j][4]).getValue()!=null)
                sum1+= ((Number)((JFormattedTextField)field[j][4]).getValue()).doubleValue();
            ((JFormattedTextField)field[25][4]).setValue(sum1);
            
            //sum of CO2
            if(((JFormattedTextField)field[j][5]).getValue()!=null){
                sum2 += ((Number)((JFormattedTextField)field[j][5]).getValue()).doubleValue();
            }
            ((JFormattedTextField)field[25][5]).setValue(sum2);
            
            //sum of Mo'olelo Score
            if(((JFormattedTextField)field[j][6]).getValue()!=null){
                sum3 += ((Number)((JFormattedTextField)field[j][6]).getValue()).doubleValue();
                count++;
            }
            
            //sum of effective carbon
            if(((JFormattedTextField)field[j][7]).getValue()!=null){
                sum4 += ((Number)((JFormattedTextField)field[j][7]).getValue()).doubleValue();
            }
            ((JFormattedTextField)field[25][7]).setValue(sum4);
        }
        if(count!=0)
        	sum3 = sum3/((double)count);
        else
        	sum3 = 0;
        ((JFormattedTextField)field[25][6]).setValue(sum3);
        
        sum = 0;
        // Top section of sums
        if(((JFormattedTextField)field[1][2]).getValue()!=null &&((JFormattedTextField)field[1][3]).getValue()!=null){
            sum = ((Number)((JFormattedTextField)field[1][2]).getValue()).doubleValue() * ((Number)((JFormattedTextField)field[1][3]).getValue()).doubleValue();
            ((JFormattedTextField)field[1][4]).setValue(sum);
            
        }
        if(((JFormattedTextField)field[2][2]).getValue()!=null &&((JFormattedTextField)field[2][3]).getValue()!=null){
            sum = ((Number)((JFormattedTextField)field[2][2]).getValue()).doubleValue() * ((Number)((JFormattedTextField)field[2][3]).getValue()).doubleValue();
            ((JFormattedTextField)field[2][4]).setValue(sum);
        }
        if(((JFormattedTextField)field[25][4]).getValue()!=null){
            sum = ((Number)((JFormattedTextField)field[25][4]).getValue()).doubleValue();
            ((JFormattedTextField)field[3][4]).setValue(sum);
        }
        sum = 0;
        if(((JFormattedTextField)field[1][4]).getValue()!=null ||((JFormattedTextField)field[2][4]).getValue()!=null || ((JFormattedTextField)field[3][4]).getValue()!=null){
            if(((JFormattedTextField)field[1][4]).getValue()!=null)
                sum = ((Number)((JFormattedTextField)field[1][4]).getValue()).doubleValue();
            if(((JFormattedTextField)field[2][4]).getValue()!=null)
                sum += ((Number)((JFormattedTextField)field[2][4]).getValue()).doubleValue();
            if(((JFormattedTextField)field[3][4]).getValue()!=null)
                sum += ((Number)((JFormattedTextField)field[3][4]).getValue()).doubleValue();
            sum = sum * 100;
            sum = Math.round(sum);
            sum = sum / 100;
            ((JLabel)field[4][4]).setText(""+sum);
        }
    }
    public void saveElement() throws FileNotFoundException, IOException{
        f = new File(fname);
        if (f == null) {
            System.out.println("f is null");
		}
		else if (!f.exists()) {
            RandomAccessFile output = new RandomAccessFile(f,"rw");
			try {
                for(int i = 1; i<3; i++){
                    for(int j = 2; j<9; j++){
                        if(j>=2 && j<4){
                            output.writeBytes(((JFormattedTextField)field[i][j]).getValue()+"\t");
                        }
                    }output.writeBytes("\n");
                }
                output.writeBytes("-\t"+((JFormattedTextField)field[25][4]).getValue()+"\n" +
                		"-\t"+((JFormattedTextField)field[25][5]).getValue()+"\n" +
                		"-\t"+((JFormattedTextField)field[25][7]).getValue()+"\n");
                
                for(int i = 6;i<22;i++){
                    if(((String)((JComboBox)field[i][0]).getSelectedItem()).compareTo("-")!=0){
                        output.writeBytes(((JComboBox)field[i][0]).getSelectedItem()+"\t");
                        if(((JFormattedTextField)field[i][2]).getValue()!=null)
                            output.writeBytes(((JFormattedTextField)field[i][2]).getValue()+"\t");
                        if(((JFormattedTextField)field[i][3]).getValue()!=null)
                            output.writeBytes(((JFormattedTextField)field[i][3]).getValue()+"\n");
                        else
                            output.writeBytes("-\n");
                    }else{
                        output.writeBytes("-\n");
                    }
                }
                //Empty fields need to be saved as well
                for(int i = 22;i<24;i++){
                	output.writeBytes(((JTextField)field[i][0]).getText()+"\t");
                	output.writeBytes(((JTextField)field[i][1]).getText()+"\t");
                	output.writeBytes(((JFormattedTextField)field[i][2]).getValue()+"\t");
                	output.writeBytes(((JFormattedTextField)field[i][3]).getValue()+"\t");
                	output.writeBytes("\n");
                }
			}
			finally {
                output.writeBytes("");
				output.close();
				g.updateReview();
			}
		}
		else if (!f.isFile()) {
            System.out.println("should not be dir: " + f);
		}
		else if (!f.canWrite()) {
            System.out.println("File cannot be written: " + f);
		}else{
            Writer output = new BufferedWriter(new FileWriter(f));
			try {
                for(int i = 1; i<3; i++){
                    for(int j = 2; j<9; j++){
                        if(j>=2 && j<4){
                            output.write(((JFormattedTextField)field[i][j]).getValue()+"\t");
                        }
                    }
                    output.write("\n");
                }
                double num1 = (Double)((JFormattedTextField)field[25][4]).getValue() * 100;
                num1 = Math.round(num1);
                num1 = num1 / 100;
                output.write("-\t"+((JFormattedTextField)field[25][4]).getValue()+"\n" +
                		"-\t"+((JFormattedTextField)field[25][5]).getValue()+"\n" +
                		"-\t"+((JFormattedTextField)field[25][7]).getValue()+"\n");
                output.flush();
                
                for(int i = 6;i<22;i++){
                    if(((String)((JComboBox)field[i][0]).getSelectedItem()).compareTo("-")!=0){
                        output.write(((JComboBox)field[i][0]).getSelectedItem()+"\t");
                        if(((JFormattedTextField)field[i][2]).getValue()!=null)
                            output.write(((JFormattedTextField)field[i][2]).getValue()+"\t");
                        if(((JFormattedTextField)field[i][3]).getValue()!=null)
                            output.write(((JFormattedTextField)field[i][3]).getValue()+"\n");
                        else
                            output.write("-\n");
                    }else{
                    	output.write("-\n");
                    }
                }
                //empty fields need to be saved as well
                for(int i = 22;i<24;i++){
                	output.write(((JTextField)field[i][0]).getText()+"\t");
                	output.write(((JTextField)field[i][1]).getText()+"\t");
                	output.write(((JFormattedTextField)field[i][2]).getValue()+"\t");
                	output.write(((JFormattedTextField)field[i][3]).getValue()+"\t");
                	output.write("\n");
                }
			}
			finally {
                output.flush();
				output.close();
				g.updateReview();
			}
		}
    }
    public void readElement(){
        // read element data saved previously
        try{
            f = new File(fname);
            if(f!=null){                
            	//System.out.println(f.getName());
                BufferedReader input =  new BufferedReader(new FileReader(f));
                try{
                    String delim = "[\t]";
                    String line = null; //not declared within while loop
                    int count = 1;
                    while ((line = input.readLine()) != null){
                        if(line.compareTo("-")!=0){
                            String[] token = line.split(delim);
                            if(count<5 && token[0]!=null && token[0].compareTo("-")!=0  && token[0].compareTo("null")!=0){
                                num = Double.parseDouble(token[0]);
                                ((JFormattedTextField)field[count][2]).setValue(num);
                            }else if(token[0].compareTo("-")==0){
                                count++;
                                continue;
                            }if(count<5 && token[1]!=null && token[1].compareTo("null")!=0){
                                num = Double.parseDouble(token[1]);
                                ((JFormattedTextField)field[count][3]).setValue(num);
                            }if((count>=6 && count<22) && token[0]!=null && token[0].compareTo("-")!=0){
                                //System.out.println(token[0]);
                                ((JComboBox)field[count][0]).setSelectedItem(token[0]);
                                num = Double.parseDouble(token[1]);
                                ((JFormattedTextField)field[count][2]).setValue(num);
                                if(token[2].compareTo("-")!=0){
                                    num = Double.parseDouble(token[2]);
                                    ((JFormattedTextField)field[count][3]).setValue(num);
                                }else
                                    ((JFormattedTextField)field[count][3]).setValue(0);
                            }else if(count>=22 && token[0]!=null && token[0].compareTo("-")!=0){
                            	//System.out.println(token[0]);
                            	((JTextField)field[count][0]).setText(token[0]);
                            	if(token[1].compareTo("null")!=0 && token[1].compareTo("-")!=0 && token[1]!=null){
                            		((JTextField)field[count][1]).setText(token[1]);
                            	}
                            	if(token[2].compareTo("null")!=0 && token[2].compareTo("-")!=0 && token[2]!=null){
                            		((JFormattedTextField)field[count][2]).setValue(Double.parseDouble(token[2]));
                            	}	
                            	if(token[3].compareTo("null")!=0 && token[3].compareTo("-")!=0 && token[3]!=null){
                            		((JFormattedTextField)field[count][3]).setValue(Double.parseDouble(token[3]));
                            	}
                            }
                        }
                        count++;
                    }
                }finally{
                    input.close();
                }
            }
        }catch (IOException ioe){
            System.out.println("read for "+fname+" did not work");
        }
        
        // read show info
        try{
            String filename = g.getDirectory() + "/" + g.getFilename();
            f = new File(filename);
            //System.out.println("got filename: "+f.getName());
            if(f != null && f.exists()){
                BufferedReader input =  new BufferedReader(new FileReader(f));
                //System.out.println("gets through the try");
                try {
                    String line = null; //not declared within while loop
                    int count = 0;
                    while ((line = input.readLine()) != null){
                        if(count == 0)
                            ((JLabel)field[2][6]).setText(line);
                        else if(count == 1)
                            ((JLabel)field[3][6]).setText(line);
                        else if(count == 2)
                            ((JLabel)field[0][6]).setText(line);
                        else if(count == 3)
                            ((JLabel)field[1][6]).setText(line);
                        else
                            break;
                        count++;
                    }
                }finally{
                    input.close();
                }
            }
        }catch (IOException ioe){
            ioe.printStackTrace();
        }
    }
}