import javax.swing.*;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
//import java.text.*;
import java.text.NumberFormat;
import java.util.LinkedList;

class Review extends JPanel implements ActionListener{
	private static final long serialVersionUID = -1154451023773719212L;
	globalvar g;
    LinkedList<String> q;
    File f;
    
    JScrollPane sp = new JScrollPane();
    JPanel main = new JPanel(new GridBagLayout());
    //JPanel bot = new JPanel(new GridLayout(1,5));
    JTextField summ = new JTextField("Summary");
    JTextField empty = new JTextField("");
    JComponent field[][] = new JComponent[100][7];
    JButton refresh = new JButton("refresh");
    
    
    String fname;
    int max = 0;
    double sum = 0;
    double num = 0;
    double suma[] = new double[7];
    //double tax = 1.13;
    
    //private NumberFormat doubleFormat;
    private GridBagConstraints material = new GridBagConstraints();
    private GridBagConstraints numbers = new GridBagConstraints();
    
    
    public Review(){
    	//scans element file names into linked list
        //scanElements();
        //initialize titles and grid
    	//doubleFormat = NumberFormat.getCurrencyInstance();
        init();
    	//System.out.println(max);

        
        ////
        refresh.addActionListener(this);
        sp.getViewport().add(main);
        setLayout(new BorderLayout());
        add(sp, BorderLayout.CENTER);
        add(refresh, BorderLayout.SOUTH);
        //pack();
		setSize(1000,500);
		setVisible(true);
    }
    public void init(){        
        /////////////////////////// preset all fields
        
        //starting gbc's
        material.fill = GridBagConstraints.HORIZONTAL;
        numbers.fill = GridBagConstraints.HORIZONTAL;
        
        material.ipady = 0;         
        material.weightx = 0.25;
        material.weighty = 0.02;
        numbers.weightx = 0.125;
        numbers.weighty = 0.02;
        
        field[0][0] = new JTextField("Production:");
        field[1][0] = new JTextField("Theatre:");
        field[2][0] = new JTextField("Director:");
        field[3][0] = new JTextField("Designer:");
        field[4][0] = new JTextField("Tech. Director:");
        field[3][2] = new JTextField("Costing Version:");
        field[4][2] = new JTextField("Costing Date:");
        for(int row = 0; row <5; row++){
            material.gridx = 0;
            material.gridy = row;           
            for(int col = 0; col<4; col++){
            	material.gridx = col;
                if(col==1){
                	field[row][col]= new JTextField("-");
                	((JTextField)field[row][col]).setEditable(false);
                }else if(row >= 3 && col==3){
                	field[row][col]= new JTextField("-");
                	((JTextField)field[row][col]).setEditable(false);
                }if(!(row <3 && col>1)){
                	main.add(field[row][col],material);
                }
            }
        }
        field[5][0] = new JTextField("Scenery");
        field[5][1] = new JTextField("Materials");
        field[5][2] = new JTextField("Set");
        field[5][3] = new JTextField("Paint");
        field[5][4] = new JTextField("Total");
        field[5][5] = new JTextField("CO2");
        field[5][6] = new JTextField("Offset");
        material.gridx = 0;
        material.gridy = 5;
    	field[5][0].setBackground(Color.yellow);
        main.add(field[5][0],material);
    	numbers.gridy = 5;
        for(int col = 1; col<7; col++){
            numbers.gridx = col;
        	field[5][col].setBackground(Color.yellow);
            ((JTextField)field[5][col]).setEditable(false);
        	main.add(field[5][col],numbers);
        }
        for(int row = 6;row<=25;row++){
            material.gridx = 0;
            material.gridy = row;
            numbers.gridy = row;
            for(int col = 0; col<7; col++){
            	numbers.gridx = col;
                if(row!=25 && col == 0){
                	field[row][col] = new JTextField("-");
                	((JTextField)field[row][col]).setEditable(false);
                    main.add(field[row][col],material);
                }else if(row!=25){
                	field[row][col] = new JFormattedTextField(NumberFormat.getNumberInstance());
                	((JFormattedTextField)field[row][col]).setEditable(false);
                	((JFormattedTextField)field[row][col]).setValue(0.0);
                    main.add(field[row][col],numbers);
                }if(row==25 && col!=0){
                	field[25][col] = new JFormattedTextField(NumberFormat.getNumberInstance());
                	field[25][col].setBackground(Color.yellow);
                	((JFormattedTextField)field[25][col]).setEditable(false);
                	main.add(field[25][col],numbers);
                }else if(row==25 &&col==0){
                	field[25][0] = new JTextField("");
                	field[25][0].setBackground(Color.yellow);
                	((JTextField)field[25][col]).setEditable(false);
                	main.add(field[25][col],numbers);
                }
            }
        }
    }
    int select;
    public void actionPerformed(ActionEvent e){ //database data gathering here
        Object source = e.getSource();
        for(int i = 0;i<7;i++)
        	suma[i] = 0;
        if(source.equals(refresh)){
        	scanElements();
        	for(int i = 0; i<max; i++){
            	//System.out.println(q.peek());
                readElement(q.poll(),i);
            }
        	for(int j = 1; j<7; j++){
        		suma[j] = suma[j]*100;
                suma[j] = Math.round(suma[j]);
                suma[j] = suma[j]/100;
        		((JFormattedTextField)field[25][j]).setValue(suma[j]);
        	}
        }
    }
    public void updateMat(){
        g.updateList();
    }
    public void updateScan(){
    	q = null;
    	for(int i = 0;i<7;i++)
        	suma[i] = 0;
    	scanElements();
    	for(int i = 0; i<max; i++){
        	//System.out.println(q.peek());
            readElement(q.poll(),i);
        }
    	for(int j = 1; j<7; j++){
    		suma[j] = suma[j]*100;
            suma[j] = Math.round(suma[j]);
            suma[j] = suma[j]/100;
    		((JFormattedTextField)field[25][j]).setValue(suma[j]);
    	}
    }
    
    public void saveReview() throws FileNotFoundException, IOException{
    	f = new File("~Review.txt");
        if (f == null) {
            System.out.println("f is null");
		}
		else if (!f.exists()) {
		}
		else if (!f.isFile()) {
            System.out.println("should not be dir: " + f);
		}
		else if (!f.canWrite()) {
            System.out.println("File cannot be written: " + f);
		}else{
            Writer output = new BufferedWriter(new FileWriter(f));
			try {
                for(int i = 1; i<3; i++){
                    for(int j = 2; j<9; j++){
                        if(j>=2 && j<4){
                            output.write(((JFormattedTextField)field[i][j]).getValue()+"\t");
                        }
                    }
                    output.write("\n");
                }
                double num1 = (Double)((JFormattedTextField)field[25][4]).getValue() * 100;
                num1 = Math.round(num1);
                num1 = num1 / 100;
                output.write("-\t"+((JFormattedTextField)field[25][4]).getValue()+"\n" +
                		"-\t"+((JFormattedTextField)field[25][5]).getValue()+"\n" +
                		"-\t"+((JFormattedTextField)field[25][7]).getValue()+"\n");
                output.flush();
                
                for(int i = 6;i<22;i++){
                    if(((String)((JComboBox)field[i][0]).getSelectedItem()).compareTo("-")!=0){
                        output.write(((JComboBox)field[i][0]).getSelectedItem()+"\t");
                        if(((JFormattedTextField)field[i][2]).getValue()!=null)
                            output.write(((JFormattedTextField)field[i][2]).getValue()+"\t");
                        if(((JFormattedTextField)field[i][3]).getValue()!=null)
                            output.write(((JFormattedTextField)field[i][3]).getValue()+"\n");
                        else
                            output.write("-\n");
                    }else{
                    }
                }
			}
			finally {
                output.flush();
				output.close();
			}
		}
    }
    public void readElement(String filename, int i){
    	num = 0;
        try{
        	fname = g.getDirectory() + "/Element/" + filename + ".txt";
            f = new File(fname);
            if(f!=null){
                //System.out.println(f.getName());
                BufferedReader input =  new BufferedReader(new FileReader(f));
                try{

                    String delim = "[\t]";
                    String line = null;
                    int count = 1;
                    ((JTextField)field[6+i][0]).setText(filename);
                    while ((line = input.readLine()) != null){
                        if(line.compareTo("-")!=0){
                            String[] token = line.split(delim);
                            if(count<=2 && token[0].compareTo("null")!=0 && token[1].compareTo("null")!=0){
                                num = Double.parseDouble(token[0]) * Double.parseDouble(token[1]);
                                num = num*100;
                                num = Math.round(num);
                                num = num/100;
                                suma[count+1]+=num;
                                ((JFormattedTextField)field[6+i][count+1]).setValue(num);
                            }else if(count==3 && token[1].compareTo("null")!=0){
                            	num = Double.parseDouble(token[1]);
                            	num = num*100;
                                num = Math.round(num);
                                num = num/100;
                                suma[1]+=num;
                            	((JFormattedTextField)field[6+i][1]).setValue(num);
                            	num += ((Number)((JFormattedTextField)field[6+i][2]).getValue()).doubleValue() + ((Number)((JFormattedTextField)field[6+i][3]).getValue()).doubleValue();
                            	num = num*100;
                                num = Math.round(num);
                                num = num/100;
                                suma[4]+=num;
                            	((JFormattedTextField)field[6+i][4]).setValue(num);
                            }else if(count==4 && token[1].compareTo("null")!=0){
                            	num = Double.parseDouble(token[1]);
                            	num = num*100;
                                num = Math.round(num);
                                num = num/100;
                                suma[5]+=num;
                            	((JFormattedTextField)field[6+i][5]).setValue(num);
                            }else if(count==5 && token[1]!=null){
                                num = Double.parseDouble(token[1]);
                                num = num*100;
                                num = Math.round(num);
                                num = num/100;
                                suma[6]+=num;
                                ((JFormattedTextField)field[6+i][6]).setValue(num);
                            }
                        }
                        count++;
                    }
                }finally{
                    input.close();
                }
            }
        }catch (IOException ioe){
            System.out.println("read for "+fname+" did not work");
        }
        
        // read show info
        try{
            String fname = g.getDirectory() + "/" + g.getFilename();
            f = new File(fname);
            if(f != null && f.exists()){
                BufferedReader input =  new BufferedReader(new FileReader(f));
                try {
                    String line = null; //not declared within while loop
                    int count = 0;
                    while ((line = input.readLine()) != null){
                        if(count == 0)
                            ((JTextField)field[3][3]).setText(line);
                        else if(count == 1)
                            ((JTextField)field[4][3]).setText(line);
                        else if(count == 2)
                            ((JTextField)field[0][1]).setText(line);
                        else if(count == 3)
                            ((JTextField)field[1][1]).setText(line);
                        else if(count == 4)
                            ((JTextField)field[2][1]).setText(line);
                        else if(count == 5)
                            ((JTextField)field[3][1]).setText(line);
                        else if(count == 6)
                            ((JTextField)field[4][1]).setText(line);
                        else
                            break;
                        count++;
                    }
                }finally{
                    input.close();
                }
            }
        }catch (IOException ioe){
            ioe.printStackTrace();
        }
    }
    public void updateGlobe(globalvar globe){
		g = globe;
	}
    public void updateFile(File f2){
		f = f2;
	}
    public void scanElements(){
        q = new LinkedList<String>();
        int count = 0;

        try{
            if(f!=null){
                BufferedReader input =  new BufferedReader(new FileReader(f));
            
                try{
                    String line = null;
                    //RandomAccessFile rand = new RandomAccessFile(f,"r"); 
                    while ((line = input.readLine()) != null){
                        if(count>=9 && (line.equals(""))){
                            count--;
                            continue;
                        }
                        if(line.equals("") || line.equals("null.txt")){
                            continue;
                        }
                        if(count>=9){
                            q.offer(line);
                            max++;
                        }
                        count++;
                    }
                }finally{
                    input.close();
                }
            }
        }catch (IOException ioe){
            ioe.printStackTrace();
        }catch (NullPointerException npe){
            npe.printStackTrace();
        }
    }
}