import javax.swing.*;

import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class Showinfo extends JPanel implements ActionListener{
	private static final long serialVersionUID = -1154451023773719212L;

	//JTextField costingv = new JTextField("Costing Version: ");
    JLabel costingv = new JLabel("Costing Version: ");
	JTextField cva = new JTextField("");
	JLabel costingd = new JLabel("Costing Date: ");
	JTextField cda = new JTextField("");
	JLabel production = new JLabel("Production: ");
	JTextField pa = new JTextField("");
	JLabel theatre = new JLabel("Theatre: ");
	JTextField ta = new JTextField("");
	JLabel director = new JLabel("Director: ");
	JTextField da = new JTextField("");
	JLabel designer = new JLabel("Designer: ");
	JTextField dea = new JTextField("");
	JLabel techdir = new JLabel("Technical Director: ");
	JTextField techda = new JTextField("");
	
	
	
	//String cv, cd, prod, thea,dir,des,tech = "";
	JButton save = new JButton("save"); //add this to test getTexts
	
	JTabbedPane jtp;
	File f;
	
	globalvar g;
	
	public Showinfo(JTabbedPane jtpc){
		JPanel titles = new JPanel();
		JPanel bottom = new JPanel();
		
		jtp = jtpc;
		setLayout(new BorderLayout());
        
		titles.setLayout(new GridLayout(7,2));
		titles.add(costingv);
		titles.add(cva);
		titles.add(costingd);
		titles.add(cda);
		titles.add(production);
		titles.add(pa);
		titles.add(theatre);
		titles.add(ta);
		titles.add(director);
		titles.add(da);
		titles.add(designer);
		titles.add(dea);
		titles.add(techdir);
		titles.add(techda);
		
		JLabel header = new JLabel("instructions");
		JLabel footer = new JLabel("");
		/*JLabel infoText2 = new JLabel(
				"<html><P>This tool is free to use and can help make green choices!"+
				"<P>To start a New Budget, simply click new budget. If you"+
				"<P>already have a budget, select the file in Open Budget."+
				"<P>If you want to work off a copy of a budget, select Copy "+
				"<P>Budget. But don't forget to set your initial defaults!</html>");
		*/
		save.addActionListener(this);
		bottom.setLayout(new GridLayout(1,2));
		bottom.add(footer);
		bottom.add(save);
		
		
		//footer.setBorder(new EmptyBorder(5,70,5,70));
		add(header, BorderLayout.NORTH);
		add(titles, BorderLayout.CENTER);
		add(bottom, BorderLayout.SOUTH);
	}
	public void updateGlobe(globalvar globe){
		g = globe;
	}
	public void updateFile(File f2){
		//System.out.println("updates f in showinfo");
		f = f2;
	}
	
	public void actionPerformed(ActionEvent e)
	{
		if (e.getSource() == save){
			jtp.setEnabledAt(2,true);
			jtp.setEnabledAt(3,true);
			jtp.setEnabledAt(4,true);
			jtp.setEnabledAt(5,true);
			try{
				createFile();
			}catch(IOException io){
				System.out.println("error");
			}
		}
	}
	public void createFile() throws FileNotFoundException, IOException 
	{
		if (f == null) {
            boolean success = (new File(pa.getText())).mkdir();
            g.updateDirectory(pa.getText());
			String s = pa.getText() + "/" + pa.getText() + cva.getText() + ".txt";
			f = new File(s);
            if(!f.isFile())
                System.out.println("f is not a file: Showinfo");
			Writer output = new BufferedWriter(new FileWriter(f));
			try {
                output.write(cva.getText()+"\n");
                output.write(cda.getText()+"\n");
                output.write(pa.getText()+"\n");
                output.write(ta.getText()+"\n");
                output.write(da.getText()+"\n");
                output.write(dea.getText()+"\n");
                output.write(techda.getText()+"\n");
                output.write(g.getTax()+"\n");
                output.write(g.getCurrency()+"\n");
                output.flush();
			}
			finally {
				output.close();
			}
		}else if (!f.exists()) {
			throw new FileNotFoundException ("File does not exist: " + f);
		}else if (!f.isFile()) {
			throw new IllegalArgumentException("Should not be a directory: " + f);
		}else if (!f.canWrite()) {
			throw new IllegalArgumentException("File cannot be written: " + f);
		}else{
			Writer output = new BufferedWriter(new FileWriter(f));
			try {
				//FileWriter always assumes default encoding is OK!
				//output.write("made file");
                output.write(cva.getText()+"\n");
                output.write(cda.getText()+"\n");
                output.write(pa.getText()+"\n");
                output.write(ta.getText()+"\n");
                output.write(da.getText()+"\n");
                output.write(dea.getText()+"\n");
                output.write(techda.getText()+"\n");
                output.write(g.getTax()+"\n");
                output.write(g.getCurrency()+"\n");
                output.flush();
			}
			finally {
				output.close();
			}
		}
        g.upload(f);
        g.updateFilename(f.getName());
	}
    public void readFile()
    {
        //System.out.println("si: " + f.getName());
        try{
            if(f != null && f.exists()){
                BufferedReader input =  new BufferedReader(new FileReader(f));
                try {
                    String line = null; //not declared within while loop
                    int count = 0;
                    while ((line = input.readLine()) != null){
                        if(count == 0)
                            cva.setText(line);
                        else if(count == 1)
                            cda.setText(line);
                        else if(count == 2){
                            pa.setText(line);
                            g.updateDirectory(line);
                        }
                        else if(count == 3)
                            ta.setText(line);
                        else if(count == 4)
                            da.setText(line);
                        else if(count == 5)
                            dea.setText(line);
                        else if(count == 6)
                            techda.setText(line);
                        else
                            break;
                        count++;
                    }
                }finally{
                    input.close();
                }
            }
        }catch (IOException ioe){
            ioe.printStackTrace();
        }
    
    }
}