import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;

public class XlsFilter extends FileFilter{
    public final static String xls = "xls";
    public final static String xlsx = "xlsx";
    
    public boolean accept(File f){
        if(f.isDirectory()){
            
            return true;
        }
        String extension = getExtension(f);
        if(extension!=null){
            if(extension.equals(xls)||
               extension.equals(xlsx)){
                //System.out.println("file accepted");
                return true;
            }
        }
        return false;
    }
    public static String getExtension(File f) {
        String ext = null;
        String s = f.getName();
        int i = s.lastIndexOf('.');
        
        if (i > 0 &&  i < s.length() - 1) {
            ext = s.substring(i+1).toLowerCase();
        }
        return ext;
    }
    public String getDescription(){
        return "Excel files";
    }
    public boolean acceptFile(File f){
        if(f.isDirectory()){
            
            return true;
        }
        String extension = getExtension(f);
        if(extension!=null){
            if(extension.equals(xls)||
               extension.equals(xlsx)){
                //System.out.println("file accepted");
                return true;
            }
        }
        return false;
    }
}