import javax.swing.*;
//import java.awt.*;
//import java.awt.event.*;
import java.io.*;

public class globalvar
{
	File f;
    String filename;
	JTabbedPane jtp;
	Welcome w;
	Showinfo s;
    Element e;
    Review r;
    Print p;
    Edit ed;
    String dir;
    private String currency = "CAD$";
    private String list[] = new String[200];
    private String listunits[] = new String[200];
    private double listvalues[] = new double[200];
    private double movalues[] = new double[200];
    private double co2values[] = new double[200];
    private double tax = 1.00;
	
	public globalvar(JTabbedPane jtpc){
		//jtp = jtpc
		w = (Welcome)jtpc.getComponentAt(0);
		s = (Showinfo)jtpc.getComponentAt(1);
        e = (Element)jtpc.getComponentAt(2);
        r = (Review)jtpc.getComponentAt(3);
        p = (Print)jtpc.getComponentAt(4);
        ed = (Edit)jtpc.getComponentAt(5);
	}
	public void upload(File f2){
		f = f2;
		//readFileDefaults();
        readList();
        w.updateFile(f2);
		s.updateFile(f2);
        s.readFile();
        e.updateFile(f2);
        e.readFile();
        p.updateFile(f2);
        r.updateFile(f2);
	}
    public void readList(){
        try{
            if(f != null){
                File mfile = new File("Materials.txt");
                BufferedReader input =  new BufferedReader(new FileReader(mfile));
                try {
                    String delim = "[\t]";
                    String line = null; //not declared within while loop
                    int count = 0;
                    while ((line = input.readLine()) != null){
                        if(count == 0)
                            list[0] = "-";
                        else{
                            String[] token = line.split(delim);
                            //System.out.println(line + token.length);
                            list[count] = token[0];
                            if(token[1]!=null)
                                listunits[count] = token[1];
                            if(token[2]!=null && token[2].compareTo("#REF!")!=0)
                                listvalues[count] = Double.parseDouble(token[2]);
                            else
                                listvalues[count] = 0;
                            if(token[3]!=null)
                                movalues[count] = Double.parseDouble(token[3]);
                            else
                                movalues[count] = -1;
                            if(token.length==5)
                                if(token[4]!=null)
                                    co2values[count] = Double.parseDouble(token[4]);
                            else
                                co2values[count] = -1;
                        }
                        count++;
                    }
                }finally{
                    input.close();
                }
            }
        }catch (IOException ioe){
            ioe.printStackTrace();
        }
    }
    public String[] updateList(){
        
        return list;
    }
    public String[] updateUnit(){
        return listunits;
    }
    public double[] updateCost(){
        return listvalues;
    }
    public double[] updateMo(){
        return movalues;
    }
    public double[] updateCO2(){
        return co2values;
    }
    public File getFile(){
    	return f;
    }
    public double getTax(){
        return tax;
    }
    public void setTax(double ntax){
        tax = ntax;
    }
    public String getCurrency(){
    	return currency;
    }
    public void setCurrency(String curr){
    	currency = curr;
    }
    public void updateDirectory(String s){
        dir = s;
    }
    public String getDirectory(){
        return dir;
    }
    public void updateFilename(String s){
        filename = s;
    }
    public String getFilename(){
        return filename;
    }
    public void updateReview(){
    	r.updateScan();
    }
    public void readFileDefaults(){
    	try{
            BufferedReader input =  new BufferedReader(new FileReader(f));
        	int count = 0;
            try{
                String line = null;
                while ((line = input.readLine()) != null){
                	//System.out.println(count + ": " + line);
                	if(count<7){
                		count++;
                		continue;
                	}else if(count==7){
                		//System.out.println(line);
                		tax = Double.parseDouble(line);
                	}else if(count==8){
                		//System.out.println(line);
                		currency = line;
                	}
                	count++;
                }
            }finally{
                input.close();
            }
        }catch (IOException ioe){
            ioe.printStackTrace();
        }
    }
}